/* Spustac httpd
 * by Marek Zelem
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <signal.h>
#include <string.h>
#include <pwd.h>
#include <grp.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <mmm/text.h>
#include <mmm/net_lib.h>
#include "computer.h"

/* inicializacia */

static int testhttpuser( char *t )
{ int n;
  char c;
	if( testsuser(t) )	return(1);
	n=0;
	while( t[n]!=0 && t[n]!=':' )	n++;
	c=t[n]; t[n]=0;
	if(	!strcmp("vix@fornax",t)
		|| !strcmp("deedman@fornax",t)
	  )
	{	t[n]=c;
		return(1);
	}
	t[n]=c;
	return(0);
}

int web_init( void )
{	return(0);
}

int web_func( int sock, char *input )
{ char *p;
	if( ( (p=strstr(input,"spusti"))!=NULL || (p=strstr(input,"start"))!=NULL )
		&& (p=strstr(p,"httpd"))!=NULL
		&& testhttpuser(input) )
	{ int fd[2];
		fd[0]=-1; fd[1]=-1;
		pipe(fd);
		foreach_process(pf_killall,(long)"httpd");
		switch( fork() )
		{  case -1:
			net_printf(sock,"Nemozem sa forknut!\n");
			break;
		   case 0:
			{ /*gid_t g*/;
				close(1);
				close(2);
				dup(fd[1]);
				dup(fd[1]);
				close(fd[0]);
				close(0);
				execl("/services/httpd/bin/httpd","httpd",
					"-d","/services/httpd","-DSSL",NULL);
				net_printf(0,"Nemozem spustit httpd\n");
				exit(0);
			}
		   default:
		   	{ int l;
			  char buf[1024];
				close(fd[1]);
				l=timeout_read(fd[0],buf,1024,1);
				if( l>0 )
					write(sock,buf,l);
				close(fd[0]);
				net_printf(sock,"httpd restartovany\n");
			}
		}
		return(1);
	}
	return(-1);
}

